package net.npaka.webviewex;
import android.app.Activity;
import android.os.Bundle;
import android.view.Window;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Toast;

//Webビュー
public class WebViewEx extends Activity {
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //Webビューの生成(1)
        WebView webView = new WebView(this);
        WebSettings settings = webView.getSettings();
        settings.setJavaScriptEnabled(true);
        settings.setSaveFormData(false);
        settings.setSupportZoom(false);

        //Webビューの通知リクエストの処理(3)
        webView.setWebViewClient(new WebViewClient() {
            //URLジャンプ時前に呼ばれる
            @Override
            public boolean shouldOverrideUrlLoading(WebView view, String url) {
                //外部ブラウザでなく内部ブラウザを利用
                return false;
            }
            
            //エラー時に呼ばれる
            @Override
            public void onReceivedError(WebView view, int errorCode,
                String description, String url) {
                toast("通信エラーです。");
            }
        }); 
        setContentView(webView); 
        
        //HTMLの読み込み(2)
        webView.loadUrl("http://npaka.net/");
    }
    
    //トーストの表示
    private void toast(String text) {
        if (text == null) text = "";
        Toast.makeText(this, text, Toast.LENGTH_LONG).show();
    } 
}