package net.npaka.gcmex;

import com.google.android.gms.gcm.GoogleCloudMessaging;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;

//Google Cloud Messaging
public class GCMEx extends Activity {
    //定数
    public final static String 
        SENDER_ID = "プロジェクト番号をココに記述",       //プロジェクト番号
        EXTRA_MESSAGE = "message",                    //メッセージ引数
        SHOW_MESSAGE = "net.npaka.gcmex.SHOW_MESSAGE";//メッセージ表示アクション
    
    //UI
    private TextView textView;
    private Handler  handler = new Handler();

    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.WHITE);
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 
        
        //テキストビューの生成
        textView=new TextView(this);
        textView.setTextColor(Color.BLACK);
        layout.addView(textView);
        
        //メッセージレシーバーの登録(1)
        registerReceiver(messageReceiver,
            new IntentFilter(SHOW_MESSAGE));
        
        //登録IDの取得(2)
        new Thread(new Runnable() {public void run() {
            try {
                GoogleCloudMessaging gcm = GoogleCloudMessaging.getInstance(GCMEx.this);
                final String regId = gcm.register(SENDER_ID);
                showMessage(GCMEx.this,"登録ID> "+regId);
            } catch (Exception e) {
                android.util.Log.e("debug", e.toString());
            }
        }}).start();
    }

    //アクティビティ破棄時に呼ばれる
    @Override
    protected void onDestroy() {
        //メッセージレシーバーの解除(1)
        unregisterReceiver(messageReceiver);

        super.onDestroy();
    }

    //メッセージの表示(1)
    public static void showMessage(Context context, String message) {
        android.util.Log.e("debug", message);
        Intent intent = new Intent(SHOW_MESSAGE);
        intent.putExtra(EXTRA_MESSAGE, message);
        context.sendBroadcast(intent);
    }

    //メッセージレシーバー(1)
    private final BroadcastReceiver messageReceiver=new BroadcastReceiver() {
        //受信時に呼ばれる
        @Override
        public void onReceive(Context context, Intent intent) {
            String message = intent.getExtras().getString(EXTRA_MESSAGE);
            textView.append(message+"\n");
        }
    };
}