package net.npaka.locationex;
import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;

//位置情報の取得
public class LocationEx extends Activity 
    implements LocationListener {
    private final static String BR = System.getProperty("line.separator");
    private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
    private TextView        textView;//テキストビュー
    private LocationManager manager; //ロケーションマネージャ
    
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout = new LinearLayout(this);
        layout.setBackgroundColor(Color.WHITE);
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 

        //テキストビューの生成
        textView = new TextView(this);
        textView.setText("LocationEx");
        textView.setTextSize(24);
        textView.setTextColor(Color.BLACK);
        textView.setLayoutParams(new LinearLayout.LayoutParams(WC, WC));
        layout.addView(textView);    
        
        //ロケーションマネージャの取得(1)
        manager = (LocationManager)getSystemService(
            Context.LOCATION_SERVICE);
    }

    //アクティビティ再開時に呼ばれる
    @Override
    public void onResume() {
        super.onResume();
        
        //ロケーションマネージャのリスナー登録(2)
        manager.requestLocationUpdates(
            LocationManager.NETWORK_PROVIDER, 0, 0, this);
    }

    //アクティビティ一時停止時に呼ばれる
    @Override
    public void onPause() {
        super.onPause();
        
        //ロケーションマネージャーの設定(3)
        manager.removeUpdates(this);
    }
    
    //位置情報変更を通知する時に呼ばれる(4)
    public void onLocationChanged(Location location) {
        //緯度と経度の取得(5)
        textView.setText("LocationEx>"+BR+
            "緯度:"+location.getLatitude()+BR+
            "経度:"+location.getLongitude());
    }

    //位置情報取得有効化を通知する時に呼ばれる(4)
    public void onProviderEnabled(String provider) {
    }

    //位置情報取得無効化を通知する時に呼ばれる(4)
    public void onProviderDisabled(String provider) {
    }

    //位置情報状態変更を通知する時に呼ばれる(4)
    public void onStatusChanged(String provider,
        int status, Bundle extras) {
    }
}