package net.npaka.usbex;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.InputDevice;
import android.view.KeyEvent;
import android.view.View;
import android.view.MotionEvent;

//USB接続
public class UsbView extends View implements
    View.OnGenericMotionListener {
    private int    keyCode    = -1;
    private float  x          = 0;
    private float  y          = 0;
    private String deviceName = "";
    
    //コンストラクタ
    public UsbView(Context context) {
        super(context);
        setBackgroundColor(Color.WHITE);

        //フォーカス指定
        setFocusable(true);
        setFocusableInTouchMode(true);
        
        //ジェネリックモーションリスナーの指定(1)
        setOnGenericMotionListener(this);
    }
    
    //描画時に呼ばれる
    @Override 
    protected void onDraw(Canvas canvas) {
        Paint paint = new Paint();
        paint.setAntiAlias(true);
        paint.setTextSize(48);
        canvas.drawText("UsbEx", 0, 60, paint);
        canvas.drawText("キーコード:"+keyCode, 0, 60*2, paint);
        canvas.drawText("X軸の値:"+x, 0, 60*3, paint);
        canvas.drawText("Y軸の値:"+y, 0, 60*4, paint);
        canvas.drawText("デバイス名:"+deviceName, 0, 60*5, paint);
    }
    
    //キーダウン時に呼ばれる
    @Override 
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        this.keyCode = keyCode;
        invalidate();
        return true;
    }

    //キーアップ時に呼ばれる
    @Override 
    public boolean onKeyUp(int keyCode, KeyEvent event) {
        this.keyCode = -1;
        invalidate();
        return true;
    }    

    //ジェネリックモーションイベント受信時に呼ばれる
    @Override
    public boolean onGenericMotion(View v, MotionEvent event) {
        //デバイス名の取得(2)
        InputDevice device = event.getDevice();
        deviceName = device.getName();
        
        keyCode = -1;
        x       = event.getX();
        y       = event.getY();
        invalidate();
        return true;
    }
}