package net.npaka.framelayoutex;
import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.view.Gravity;
import android.view.Window;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.LinearLayout;

//フレームレイアウト
public class FrameLayoutEx extends Activity {
    private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int MP = LinearLayout.LayoutParams.MATCH_PARENT;

    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        FrameLayout layout = new FrameLayout(this);
        layout.setBackgroundColor(Color.WHITE);
        setContentView(layout);     
                
        //ヘッダの生成
        LinearLayout header = new LinearLayout(this);
        header.setBackgroundColor(Color.TRANSPARENT);
        header.setGravity(Gravity.TOP);//上寄せ
        
        //ヘッダボタンの生成
        Button btnHeader = new Button(this);
        btnHeader.setText("ヘッダ");
        btnHeader.setLayoutParams(new LinearLayout.LayoutParams(MP, WC));
        header.addView(btnHeader);
        layout.addView(header);

        //フッタの生成
        LinearLayout footer = new LinearLayout(this);
        footer.setBackgroundColor(Color.TRANSPARENT);
        footer.setGravity(Gravity.BOTTOM);//下寄せ
        layout.addView(footer);

        //フッタボタンの生成
        Button btnFooter = new Button(this);
        btnFooter.setText("フッタ");
        btnFooter.setLayoutParams(new LinearLayout.LayoutParams(MP, WC));
        footer.addView(btnFooter);
    } 
}